/*
	general class for accessing data through different protocols
*/

import java.io.*;
import java.util.*;

public class dataModule {

	dataAccess internalModule = null;

	public void open(String protocol, String location, String id, String pwd) {

		internalModule = ModuleFactory.createModule(protocol);

		if (internalModule != null) {  

			internalModule.open(protocol, location, id, pwd);

		} else {

			try {

				throw new SessionOpenException();

			} catch (Exception e) {

				e.printStackTrace();
			}
		}
	}


	public void close() {

		if (internalModule != null) {  

			internalModule.close();

		} else {

			try {

				throw new SessionOpenException();

			} catch (Exception e) {

				e.printStackTrace();
			}
		}
	}


	public String getValue(String name, String key) {

		String result = null;

		if (internalModule != null) {  

			result = internalModule.getValue(name, key);

		} else {

			try {

				throw new SessionOpenException();

			} catch (Exception e) {

				e.printStackTrace();
			}
		}

		return result;
	}


	public Enumeration getUsers() {

		Enumeration result = null;
		
		if (internalModule != null) {  

			result = internalModule.getUsers();

		} else {

			try {

				throw new SessionOpenException();

			} catch (Exception e) {

				e.printStackTrace();
			}
		}

		return result;
	}


	public void addUser(String name) {

		if (internalModule != null) {   

			internalModule.addUser(name);

		} else {

			try {

				throw new SessionOpenException();

			} catch (Exception e) {

				e.printStackTrace();
			}
		}
	}


	public void removeUser(String name) {

		if (internalModule != null) {  

			internalModule.removeUser(name);

		} else {

			try {

				throw new SessionOpenException();

			} catch (Exception e) {

				e.printStackTrace();
			}
		}
	}


	public Enumeration getUserKeys(String name) {

		Enumeration result = null;

		if (internalModule != null) { 

			result = internalModule.getUserKeys(name);

		} else {

			try {

				throw new SessionOpenException();

			} catch (Exception e) {

				e.printStackTrace();
			}
		}

		return result;
	}


	public void setValue(String name, String key, String value) {

		if (internalModule != null) {  
	
			internalModule.setValue(name, key, value);

		} else {

			try {

				throw new SessionOpenException();

			} catch (Exception e) {

				e.printStackTrace();
			}
		}
	}


	public void removeKey(String name, String key) {

		if (internalModule != null) {  

			internalModule.removeKey(name, key);

		} else {
	
			try {

				throw new SessionOpenException();

			} catch (Exception e) {

				e.printStackTrace();
			}
		}
	}
}



