/*
	specific implemetation for accessing data in the file
*/

import java.io.*;
import java.util.*;
import java.lang.*;

public class fileModule implements dataAccess {

	private BufferedReader openBufReader = null;
	private FileReader fReader;
	private File locationFile;
	private String gFilename = null;

	public void open(String protocol, String location, String id, String pwd) {

		gFilename = location;
		locationFile = new File(location);

		if (!locationFile.exists()) {

			try {

				throw new java.io.FileNotFoundException(location);

			} catch (FileNotFoundException e) {

				e.printStackTrace();
			}
		}
	}

	public void close() {

		if (openBufReader != null) {

			try {

				openBufReader.close();

			} catch(Exception e) {

				e.printStackTrace();
			}
		}
	}
	

	public String getValue(String name, String key) {

		String line = null, tag = null;
		Hashtable tableUserKeys = new Hashtable();
		Object keyValue = new Object();
		Object userName = new Object();

		if (!openFile(gFilename)) 
			return null;
		
		do {

			try {

				line = openBufReader.readLine();

			} catch (Exception e) {

				e.printStackTrace();
			}

			if (line != null) {

				line = line.trim();
				tag = getFirstSubstring(line, "<", ">");

				if (tag != null && tag.toLowerCase().equals("user")) {

					tableUserKeys.clear();
					tableUserKeys = getUserKeyList();
					userName = tableUserKeys.get("name");

					if (userName != null 
						&& userName.toString().equals(name)) {

						keyValue = tableUserKeys.get(key);

						if (keyValue != null) {

							return keyValue.toString();

						} else {

							// when the specified key does not exist

							return null;
						}
					}
				}

			} else {

				// when the user with specified name does not exist
	
				return null;
			}

		} while (true);
	}

	public Enumeration getUsers() {
	
		String line = null, tag = null;
		Vector userList = new Vector(20);
		Object userName = new Object();
		Hashtable tableUserKeys = new Hashtable();

		if (!openFile(gFilename)) 
			return null;

		do {

			try {

				line = openBufReader.readLine();
	
			} catch (Exception e) {

				e.printStackTrace();

			}

			if (line != null) {

				line = line.trim();
				tag = getFirstSubstring(line, "<", ">");

				// add the name whenerver we meet the <user> tag
				if (tag != null && tag.toLowerCase().equals("user")) {

					tableUserKeys.clear();
					tableUserKeys = getUserKeyList();
					userName = tableUserKeys.get("name");

					if (userName != null) {
						userList.addElement(userName.toString());
					}
				}

			} else {

				return userList.elements();

			}

		} while (true);
	}

	public Enumeration getUserKeys(String name) {

		String line = null, tag = null;
		Hashtable tableUserKeys = new Hashtable();
		Object userName = new Object();

		if (!openFile(gFilename)) 
			return null;

		do {

			try {

				line = openBufReader.readLine();

			} catch (Exception e) {

				e.printStackTrace();

			}

			if (line != null) {

				line = line.trim();
				tag = getFirstSubstring(line, "<", ">");

				if (tag != null && tag.toLowerCase().equals("user")) {

					tableUserKeys.clear();
					tableUserKeys = getUserKeyList();
					userName = tableUserKeys.get("name");

					if (userName != null && userName.toString().equals(name)) {
						return tableUserKeys.keys();
					}
				}

			} else {

					// when user with specified name does not exist

					return null;
			}

		} while (true);
	}


	private boolean openFile(String location) {

		// close the input stream first if it is already open

		close();

		try {

			locationFile = new File(location);

			if (!locationFile.exists()) {

				throw new java.io.FileNotFoundException(location);
			}

			fReader = new FileReader(locationFile);
			openBufReader = new BufferedReader(fReader);

		} catch(Exception e) {

			e.printStackTrace();
			return false;
		}

		return true;
	}


	private FileWriter fileWriter;
	private FileReader tmpFileReader;
	private BufferedWriter bufWriter;
	private BufferedReader bufReader;
	private File tmpFile;


/*
	public void addUser(String name) 

	: Creates new user entry in the file of the form;

	  <user>
	  <name>'name'</name>
	  </user>

	  If the user of the given name already exist, all keys are
	  removed and added as shown  above.
*/

	public void addUser(String name) {

		String tag, line = null;
		String nameTag;

		try {

			if (!openReaderWriter(gFilename)) {

				throw new java.io.FileNotFoundException(gFilename);
			}

		} catch (Exception e) {

			e.printStackTrace();
			return;
		}

		do {

			try {

				line = bufReader.readLine();

			} catch (Exception e) {

				e.printStackTrace();

			}

			if (line != null) {

				line = line.trim();
				tag = getFirstSubstring(line, "<", ">");

				if (tag != null && tag.toLowerCase().equals("user")) {

					try {

						// write all keys within user section to file

						addingUser(name);

					} catch (IOException e) {

						e.printStackTrace();
					}
				}

			} else {

				// exit the loop when we meet end of file

				break;
			}

		} while (true);

		// add the new user with the given name to file

		nameTag = "<name>" + name + "</name>";

		try {

			bufWriter.write("<user>", 0, 6);
			bufWriter.newLine();
			bufWriter.flush();
			bufWriter.write(nameTag, 0, nameTag.length());
			bufWriter.newLine();
			bufWriter.flush();
			bufWriter.write("</user>", 0, 7);
			bufWriter.newLine();
			bufWriter.flush();

			closeReaderWriter();

		} catch (IOException e) {

			e.printStackTrace();
		}
	}


/*
	public void removeUser(String name)

	: Removes the user entry from the file, i.e. all tags including
	  <user> tag. 
	  If the user with the specified name does not exist, it does
	  nothing.
*/

	public void removeUser(String name) {

		String tag, line = null;

		try {

			if (!openReaderWriter(gFilename)) {

				throw new java.io.FileNotFoundException(gFilename);
			}

		} catch (Exception e) {

			e.printStackTrace();
			return;
		}		

		do {

			try {

				line = bufReader.readLine();

			} catch (IOException e) {

				e.printStackTrace();
			}

			if (line != null) {

				line = line.trim();
				tag = getFirstSubstring(line, "<", ">");

				if (tag != null && tag.toLowerCase().equals("user")) {

					// write all keys within user section to file

					try {

						removingUser(name);

					} catch (IOException e) {

						e.printStackTrace();
					}
				}

			} else {

				// exit the loop when we meet end of file

				break;
			}

		} while (true);

		try {

			closeReaderWriter();

		} catch (Exception e) {

			e.printStackTrace();
		}
	}


/*
	public void setValue(String name, String key, String value)  

	: Modifies value of the key for given user in a particular file.
	  If the key does not exist, the key is created.
	  If the user with specified name does not exist, it does nothing.
*/

	public void setValue(String name, String key, String value) {

		String tag, line = null;

		try {

			if (!openReaderWriter(gFilename)) {

				throw new java.io.FileNotFoundException(gFilename);
			}

		} catch (Exception e) {

			e.printStackTrace();
			return;
		}

		do {

			try {

				line = bufReader.readLine();

			} catch (Exception e) {

				e.printStackTrace();
			}

			if (line != null) {

				line = line.trim();
				tag = getFirstSubstring(line, "<", ">");

				if (tag != null && tag.toLowerCase().equals("user")) {

					try {

						// write all keys within user section to file

						settingValue(name, key, value);

					} catch (IOException e) {

						e.printStackTrace();
					}
				}

			} else {

				// exit the loop when we meet end of file

				break;
			}

		} while(true);

		try {

			closeReaderWriter();

		} catch (IOException e) {

			e.printStackTrace();
		}
	}



/*
	public void removeKey(String name, String key) 

	: Removes the key from the data about the user in particular file.
	  If user with specified name does not exist or if the specified key
	  does not exist, it does nothing.
*/

	public void removeKey(String name, String key) { 

		String tag, line = null;

		try {

			if (!openReaderWriter(gFilename)) {

				throw new java.io.FileNotFoundException(gFilename);
			}

		} catch (IOException e) {
				
			e.printStackTrace();
			return;
		}

		do {

			try {

				line = bufReader.readLine();

			} catch (Exception e) {

				e.printStackTrace();
			}

			if (line != null) {

				line = line.trim();
				tag = getFirstSubstring(line, "<", ">");

				if (tag != null && tag.toLowerCase().equals("user")) {

					try {

						// write all key within user section to file

						removingKey(name, key);

					} catch (IOException e) {
	
						e.printStackTrace();
					}
				}

			} else {

				// exit the loop when we meet end of file

				break;
			}

		} while (true);

		try {

			closeReaderWriter();

		} catch (IOException e) {

			e.printStackTrace();
		}
	}


/*
	private boolean openReaderWriter(String filename) throws IOException

	: create the input and output stream
	  return true if it is done successfully, 
	  or return false if the given file does not exist
*/

	private boolean openReaderWriter(String filename) throws IOException { 

		String originName, tmpName;
		File filenameFile, originFile;

		// close the input stream first if it is already open
 
		close();

		originName = filename;
		tmpName = filename + ".tmp";

		// create temporary file

		tmpFile = new File(tmpName);

		// open the file

		filenameFile = new File(filename);

		if (!filenameFile.exists()) {

			// if the given file does not exist

			return false;
		}

		// make the current file temporary file

		filenameFile.renameTo(tmpFile);

		try {

			// create stream to read from the file

			tmpFileReader = new FileReader(tmpFile);
			bufReader = new BufferedReader(tmpFileReader);

		} catch (FileNotFoundException e) {

			e.printStackTrace();
		}

		// create the new file 

		originFile = new File(originName);

		// create write stream to the new file

		fileWriter = new FileWriter(originFile);
		bufWriter = new BufferedWriter(fileWriter);

		return true;
	}


	private void closeReaderWriter() throws IOException { 

		if (bufReader != null) {

			bufReader.close();
		}

		bufWriter.close();
		tmpFile.delete();
	}


/*
	private Hashtable getUserKeyList() 

	: retrieve all key within <user></user> section
*/	

	private Hashtable getUserKeyList() {

		Hashtable result = new Hashtable();
		String line = null;
		String tagKey = null, endTagKey = null, valueKey = null;


		do {

			try {

				line = openBufReader.readLine();

			} catch (Exception e) {

				e.printStackTrace();
			}

			if (line != null) {

				line = line.trim();
				tagKey = getFirstSubstring(line, "<", ">");

				if (tagKey != null) {

					if(!tagKey.toLowerCase().equals("/user")) {

						endTagKey = getLastSubstring(line, "</", ">");
						tagKey = tagKey.toLowerCase();

						if (endTagKey != null && 
							endTagKey.toLowerCase().equals("/" + tagKey)) {
							valueKey = getFirstSubstring(line, ">", "</");
							result.put(tagKey, valueKey);
						}

					} else {

						return result;
					}
				}

			} else {

				return result;
			}
				
		} while (true);
	}


/*
	private String getFirstSubstring(String str, String from, String to)

	: return the new string which is the substring of the original string.
	  It starts and ends at the first index of specified string deliminators.
	  If there's no matched substring, return null.
*/

	private String getFirstSubstring(String str, String from, String to) {

		int startIndex, endIndex;
		String substr = null;

		try {

			if (str.length() > 0) {
				startIndex = str.indexOf(from) + 1;
				endIndex = str.indexOf(to);
				if (startIndex < endIndex) {
					substr = str.substring(startIndex, endIndex);
				}
			}

		} catch (Exception e) {

			e.printStackTrace();
		}

		return substr;
	}

/*
	private String getLastSubstring(String str, String from, String to)

	: return the new string which is the substring of the original string.
	  It starts and ends at the last index of specified string deliminators.
	  If there's no matched substring, return null
*/

	private String getLastSubstring(String str, String from, String to) {

		int startIndex, endIndex;
		String substr = null;

		try { 

			if (str.length() > 0) {
				startIndex = str.lastIndexOf(from) + 1;
				endIndex = str.lastIndexOf(to);
				if (startIndex < endIndex) {
					substr = str.substring(startIndex, endIndex);
				}
			}

		} catch (Exception e) {

			e.printStackTrace();
		}

		return substr;
	}
 

/*
	private void removingKey(String name, String key) throws IOException

	: If the key of the specified name is found, skip that data.
	  Otherwise, write the whole data to file
*/

	private void removingKey(String name, String key) throws IOException { 

		String targetLine = null;
		String nextLine = null;
		String userName;
		String tag = null;
		boolean foundUser = false;
		boolean foundKey = false;
		boolean existed = false;

		// write "<user>" to file

		bufWriter.write("<user>", 0, 6);
		bufWriter.newLine();
		bufWriter.flush();

		do {

			try {
	
				nextLine = bufReader.readLine();
	
			} catch (Exception e) {

				e.printStackTrace();
			}

			if (nextLine != null) {

				nextLine = nextLine.trim();
				tag = getLastSubstring(nextLine, "</", ">");

				if (tag != null) {

					if (!tag.toLowerCase().equals("/user")) {

						if (!existed && containsKey(nextLine, key)) {
							targetLine = nextLine;
							foundKey = true;
							existed = true;
						}

						if (!foundUser && containsKey(nextLine, "name")) {
							userName = getFirstSubstring(nextLine, ">", "</");
							if (userName != null && userName.equals(name)) {
								foundUser = true;
							}
						}

						if (!foundKey) {
								bufWriter.write(nextLine, 0, nextLine.length());
								bufWriter.newLine();
								bufWriter.flush();
						} else {
							foundKey = false;
						}

					} else {

						// exit the loop when </user> tag is found

						break;
					}
				}

			} else {

				// exit the loop when the end of file is found

				break;
			}

		} while (true);

		if (!foundUser && existed) {

			bufWriter.write(targetLine, 0, targetLine.length());
			bufWriter.newLine();
			bufWriter.flush();
		}

		// write </user> to the file

		if (nextLine != null) {

			bufWriter.write(nextLine, 0, nextLine.length());
			bufWriter.newLine();
			bufWriter.flush();
		}
	}


/*
	private void addingUser(String name) throws IOException

	: If the key of the specified name is found, the value is changed.
	  If the user with the given name does not have the specified key,  
	  add the key and its value to file.
*/

	private void addingUser(String name) throws IOException { 

		String nextLine = null;
		String userName;
		String tag = null;
		String userEntry = "<user>";
		boolean foundUser = false;
		
		do {

			try {

				nextLine = bufReader.readLine();

			} catch (Exception e) {

				e.printStackTrace();
			}
	
			if (nextLine != null) {

				nextLine = nextLine.trim();
				tag = getLastSubstring(nextLine, "</", ">");

				if (tag != null) {

					if (!tag.toLowerCase().equals("/user")) {

						if (!foundUser && containsKey(nextLine, "name")) {
							userName = getFirstSubstring(nextLine, ">", "</");
							if (userName != null && userName.equals(name)) {
								foundUser = true;
							}
						} 
			
						userEntry = userEntry + "\n" + nextLine;

					} else {

						// exit the loop when </user> tag is found

						break;
					}
				}

			} else {

				// exit the loop when end of file is found

				break;
			}

		} while (true);

		if (!foundUser) {

			// write the all entries about the user to file

			bufWriter.write(userEntry, 0, userEntry.length());
			bufWriter.newLine();
			bufWriter.flush();

			if (nextLine != null) {

				// write "</user>" tag to file

				bufWriter.write(nextLine, 0, nextLine.length());
				bufWriter.newLine();
				bufWriter.flush();
			}
		}
	}


/*
	private void removingUser(String name) throws IOException

	: If the key of the specified name is found, the value is changed.
	  If the user with the given name does not have the specified key,  
	  add the key and its value to file.
*/

	private void removingUser(String name) throws IOException { 

		String nextLine = null;
		String userName, userEntry = "<user>";
		String tag = null;
		boolean foundUser = false;
		
		do {

			try {

				nextLine = bufReader.readLine();

			} catch (Exception e) {

				e.printStackTrace();
			}
	
			if (nextLine != null) {

				nextLine = nextLine.trim();
				tag = getLastSubstring(nextLine, "</", ">");

				if (tag != null) {

					if (!tag.toLowerCase().equals("/user")) {

						if (!foundUser && containsKey(nextLine, "name")) {
							userName = getFirstSubstring(nextLine, ">", "</");
							if (userName != null && userName.equals(name)) {
								foundUser = true;
							}
						}

						userEntry = userEntry + "\n" + nextLine;

					} else {

						// exit the loop when </user> tag is found

						break;
					}
				}

			} else {

				// exit the loop when end of file is found

				break;
			}

		} while (true);

		if (!foundUser) {
			
			// write the data about user to file

			bufWriter.write(userEntry, 0, userEntry.length());
			bufWriter.newLine();
			bufWriter.flush();

			// write "</user>" to file

			if (nextLine != null) {

				bufWriter.write(nextLine, 0, nextLine.length());
				bufWriter.newLine();
				bufWriter.flush();
			}
		}
	}


/*
	private void settingValue(String name, String key, String value)

	: If the key of the specified name is found, the value is changed.
	  If the user with the given name does not have the specified key,  
	  add the key and its value to file.
*/

	private void settingValue(String name, String key, String value) throws IOException { 

		String modifiedLine = null;
		String oldLine = null;
		String nextLine = null;
		String userName;
		String tag = null;
		boolean foundUser = false;
		boolean foundKey = false;
		boolean existed = false;
		
		// write "<user>" to file

		bufWriter.write("<user>", 0, 6);
		bufWriter.newLine();
		bufWriter.flush();

		do {

			try {

				nextLine = bufReader.readLine();

			} catch (Exception e) {

				e.printStackTrace();
			}
	
			if (nextLine != null) {

				nextLine = nextLine.trim();
				tag = getLastSubstring(nextLine, "</", ">");

				if (tag != null) {

					if (!tag.toLowerCase().equals("/user")) {

						if (!existed && containsKey(nextLine, key)) {
							modifiedLine = "<"+key+">"+value+"</"+key+">";
							oldLine = nextLine;
							foundKey = true;
							existed = true;
						}

						if (!foundUser && containsKey(nextLine, "name")) {
							userName = getFirstSubstring(nextLine, ">", "</");
							if (userName != null && userName.equals(name)) {
								foundUser = true;
							}
						}

						if (!foundKey) {
	
							// if the specified key does not exist

							bufWriter.write(nextLine, 0, nextLine.length());
							bufWriter.newLine();
							bufWriter.flush();

						} else {

							foundKey = false;
						}

					} else {

						// exit the loop when </user> tag is found

						break;
					}
				}

			} else {

				// exit the loop when end of file is found

				break;
			}

		} while (true);

		if (foundUser) {

			if (!existed) {

				// if the key does not exist, it is created

				modifiedLine = "<"+key+">"+value+"</"+key+">";
			}

			bufWriter.write(modifiedLine, 0, modifiedLine.length());
			bufWriter.newLine();
			bufWriter.flush();

		} else {

			if (existed) {

				bufWriter.write(oldLine, 0, oldLine.length());
				bufWriter.newLine();
				bufWriter.flush();
			}
		}

		// write "</user>" to file

		if (nextLine != null) {

			bufWriter.write(nextLine, 0, nextLine.length());
			bufWriter.newLine();
			bufWriter.flush();
		}
	}


/*
	private boolean containsKey(String line, String key)

	: return true if the string contains the specified key
*/

	private boolean containsKey(String line, String key) {

		String tag, endTag;

		if (line != null && line.length() > 0) {

			tag = getFirstSubstring(line, "<", ">");
			endTag = getLastSubstring(line, "</", ">");

			if (tag != null && endTag != null && 
				endTag.toLowerCase().equals("/" + tag.toLowerCase())) {

				if (tag.toLowerCase().equals(key)) {
					return true;
				}
			}
		}

		return false;
	}

}


