/*
	specific implementation for accessing data in the web server
*/

import java.util.*;
import java.lang.*;
import java.net.*;
import java.io.*;

public class httpModule implements dataAccess {

	private URL my_url;
	private URLConnection url_conn;
	private BufferedReader bufReader;
	private InputStreamReader inStrmReader;

	public void open(String protocol, String location, String id, String pwd) {

		try {

			my_url = new URL(location);

		} catch (MalformedURLException e) {

			e.printStackTrace();
		}
	}

	public void close() {

		if (bufReader != null) {

			try {

				bufReader.close();

			} catch (IOException e) {

				e.printStackTrace();
			}
		}
	}

	public String getValue(String name, String key) {

		String line = null, tag = null;
        Hashtable tableUserKeys = new Hashtable();
        Object keyValue = new Object();
        Object userName = new Object();

		// close the input stream first if it is already open

		close();

		try {
	
			url_conn = my_url.openConnection();
			inStrmReader = new InputStreamReader(url_conn.getInputStream());
			bufReader = new BufferedReader(inStrmReader);

		} catch (Exception e) {

			e.printStackTrace();
			return null;
		}
   
        do {

            try {

                line = bufReader.readLine();

            } catch (Exception e) {

                e.printStackTrace();
            }

            if (line != null) {

                line = line.trim();
                tag = getFirstSubstring(line, "<", ">");

                if (tag != null && tag.toLowerCase().equals("user")) {

                    tableUserKeys.clear();
                    tableUserKeys = getUserKeyList();
                    userName = tableUserKeys.get("name");

                    if (userName != null && userName.toString().equals(name)) {

                        keyValue = tableUserKeys.get(key);

                        if (keyValue != null) {

                            return keyValue.toString();

                        } else {

                            // when the specified key does not exist

                            return null;
                        }
                    }
                }

            } else {

                // when the user with specified name does not exist

                return null;
            }

		} while (true);
	}

	public void setValue(String name, String key, String value) {

		try {

			throw new IllegalModificationException();

		} catch (Exception e) {

			e.printStackTrace();
		}
	}

	public void removeKey(String name, String key) {

		try {

			throw new IllegalModificationException();

		} catch (Exception e) {

			e.printStackTrace();
		}
	}

	public Enumeration getUsers() {

        String line = null, tag = null;
        Vector userList = new Vector(20);
        Object userName = new Object();
        Hashtable tableUserKeys = new Hashtable();

		// close the input stream first if it is already open

		close();

		try {
	
			url_conn = my_url.openConnection();
			inStrmReader = new InputStreamReader(url_conn.getInputStream());
			bufReader = new BufferedReader(inStrmReader);

		} catch (Exception e) {

			e.printStackTrace();
			return null;
		}

        do {

            try {

                line = bufReader.readLine();
   
            } catch (Exception e) {

                e.printStackTrace();

            }

            if (line != null) {

                line = line.trim();
                tag = getFirstSubstring(line, "<", ">");

                // add the name whenerver we meet the <user> tag
                if (tag != null && tag.toLowerCase().equals("user")) {

                    tableUserKeys.clear();
                    tableUserKeys = getUserKeyList();
                    userName = tableUserKeys.get("name");

                    if (userName != null) {
                        userList.addElement(userName.toString());
                    }
                }

            } else {

                return userList.elements();
            }

        } while (true);
	}

	public Enumeration getUserKeys(String name) {

        String line = null, tag = null;
        Hashtable tableUserKeys = new Hashtable();
        Object userName = new Object();

		// close the input stream first if it is already open

		close();

		try {
	
			url_conn = my_url.openConnection();
			inStrmReader = new InputStreamReader(url_conn.getInputStream());
			bufReader = new BufferedReader(inStrmReader);

		} catch (Exception e) {

			e.printStackTrace();
			return null;
		}

        do {

            try {

                line = bufReader.readLine();

            } catch (Exception e) {

                e.printStackTrace();

            }

            if (line != null) {

                line = line.trim();
                tag = getFirstSubstring(line, "<", ">");

                if (tag != null && tag.toLowerCase().equals("user")) {

                    tableUserKeys.clear();
                    tableUserKeys = getUserKeyList();
                    userName = tableUserKeys.get("name");

                    if (userName != null && userName.toString().equals(name)) {
                        return tableUserKeys.keys();
                    }
                }

            } else {

                    // when user with specified name does not exist

                    return null;
            }

        } while (true);
	}

	public void addUser(String name) {

		try {

			throw new IllegalModificationException();

		} catch(Exception e) {

			e.printStackTrace();
		}
	}
	
	public void removeUser(String name) {

		try {

			throw new IllegalModificationException();

		} catch(Exception e) {

			e.printStackTrace();
		}
	}

/*
    private String getFirstSubstring(String str, String from, String to)

    : return the new string which is the substring of the original string.
      It starts and ends at the first index of specified string deliminators.
      If there's no matched substring, return null.
*/

    private String getFirstSubstring(String str, String from, String to) {

        int startIndex, endIndex;
        String substr = null;

        try {

            if (str.length() > 0) {
                startIndex = str.indexOf(from) + 1;
                endIndex = str.indexOf(to);
                if (startIndex < endIndex) {
                    substr = str.substring(startIndex, endIndex);
                }
            }

        } catch (Exception e) {

            e.printStackTrace();
        }

        return substr;
    }

/*
	private Hashtable getUserKeyList()

    : retrieve all key within <user></user> section
*/ 

	private Hashtable getUserKeyList() {

        Hashtable result = new Hashtable();
        String line = null;
        String tagKey = null, endTagKey = null, valueKey = null;


        do {

            try {

                line = bufReader.readLine();

            } catch (Exception e) {

                e.printStackTrace();
            }

            if (line != null) {

                line = line.trim();
                tagKey = getFirstSubstring(line, "<", ">");

                if (tagKey != null) {

                    if(!tagKey.toLowerCase().equals("/user")) {

                        endTagKey = getLastSubstring(line, "</", ">");
                        tagKey = tagKey.toLowerCase();

                        if (endTagKey != null &&
                            endTagKey.toLowerCase().equals("/" + tagKey)) {
                           valueKey = getFirstSubstring(line, ">", "</");
                            result.put(tagKey, valueKey);
                        }

                    } else {

                        return result;
                    }
                }

            } else {

                return result;
            }

        } while (true);
    }


/*
	private String getLastSubstring(String str, String from, String to)

    : return the new string which is the substring of the original string.
      It starts and ends at the last index of specified string deliminators.
      If there's no matched substring, return null
*/

    private String getLastSubstring(String str, String from, String to) {

        int startIndex, endIndex;
        String substr = null;

        try {

            if (str.length() > 0) {
                startIndex = str.lastIndexOf(from) + 1;
                endIndex = str.lastIndexOf(to);
                if (startIndex < endIndex) {
                    substr = str.substring(startIndex, endIndex);
                }
            }

        } catch (Exception e) {

            e.printStackTrace();
        }

        return substr;
    }
}

