/*
	specific implementation for accessing data in LDAP server
*/

import javax.naming.*;
import javax.naming.directory.*;

import java.util.*;

public class ldapModule implements dataAccess {

	public static String MY_INITCTX = "com.sun.jndi.ldap.LdapCtxFactory";

	Hashtable env = new Hashtable(5, 075f);
	String my_url, my_principal, my_credentials;

	public void open(String protocol, String location, String id, String pwd) {

		my_url = location;
		my_principal = id;
		my_credentials = pwd;

		env.put(Context.INITIAL_CONTEXT_FACTORY, MY_INITCTX); 
		env.put(Context.PROVIDER_URL, my_url);
		env.put(Context.SECURITY_AUTHENTICATION, "simple");
/*
		env.put(Context.SECURITY_PRINCIPAL, my_principal);
		env.put(Context.SECURITY_CREDENTIALS, my_credentials);
*/
	}

	public void close() {
	}

	public String getValue(String name, String key) {

		DirContext dCtx;
		Attributes attrs;
		Attribute attr;
		String ret_val = null;
	
		try {

			dCtx = new InitialDirContext(env);
			attrs = dCtx.getAttributes(name);

			if (attrs != null) {

				attr = attrs.get(key);
				if (attr != null) {
					ret_val = (String) attr.get();
				}
			}
			
		} catch (NamingException e) {

			e.printStackTrace();
		}

		return ret_val;
	}

	public Enumeration getUsers() {

		Vector list_users = new Vector(10);

		return list_users.elements();
	}

	public void addUser(String name) {
	}

	public void removeUser(String name) {
	}

	public Enumeration getUserKeys(String name) {

		DirContext dCtx;
		Attributes attrs;
		Attribute attr;
		String attrID;
		NamingEnumeration all_attrs;
		Vector ret_keys = new Vector(10);

		try {

			dCtx = new InitialDirContext(env);
			attrs = dCtx.getAttributes(name);

			if (attrs != null) {
				for (all_attrs = attrs.getAll(); all_attrs.hasMoreElements(); ) {
					attr = (Attribute) all_attrs.next();
					attrID = attr.getID();
					ret_keys.addElement(attrID);
				}
			}

		} catch (NamingException e) {

			e.printStackTrace();
		}

		return ret_keys.elements();
	}

	public void setValue(String name, String key, String value) {

		DirContext dCtx;
		ModificationItem[] mods = new ModificationItem[1];
		Attributes attrs;
		Attribute attr, new_attr;

		try {

			dCtx = new InitialDirContext(env);
			attrs = dCtx.getAttributes(name);

			if (attrs != null) {

				attr = attrs.get(key);
				new_attr = new BasicAttribute(key, value);

				if (attr != null) {

					// modify the value if the given key exists

					mods[0] = new ModificationItem(DirContext.REPLACE_ATTRIBUTE, new_attr);

				} else {

					// add the key and it value if the given key does not exist

					mods[0] = new ModificationItem(DirContext.ADD_ATTRIBUTE, new_attr);
				}

				dCtx.modifyAttributes(name, mods);
			}

		} catch (NamingException e) {

			e.printStackTrace();
		}
	}

	public void removeKey(String name, String key) {

		DirContext dCtx;
		ModificationItem[] mods = new ModificationItem[1];
		Attribute attr = new BasicAttribute(key);

		try {

			dCtx = new InitialDirContext(env);

			mods[0] = new ModificationItem(DirContext.REMOVE_ATTRIBUTE, attr);
			dCtx.modifyAttributes(name, mods);

		} catch (NamingException e) {

			e.printStackTrace();
		}
	}
}

